#!/bin/sh

#####check, if second instance is running#####
if [ -f ./data/billvol.pid ]; then
  pid=$(cat ./data/billvol.pid)
  rm ./data/billvol.pid
fi
if [ "$pid" = "" ]; then
  pid="wrtbwlog_nopid"
fi
echo $$ > ./data/billvol.pid
      
if [ "$(ps|grep $pid|grep billvol.sh)" != "" ]; then
  kill $pid
fi

#####get current date#####
day=$(date +"%d")
month=$(date +"%m")
year=$(date +"%y")

#####get config data#####
if [ -f "./data/config" ]; then
  start="$(cat "./data/config"|grep "wrt_stbill"|cut -d '=' -f2)"
  limit1="$(cat "./data/config"|grep "wrt_limit1"|cut -d '=' -f2)"
  limit2="$(cat "./data/config"|grep "wrt_limit2"|cut -d '=' -f2)"
  aclim1="$(cat "./data/config"|grep "wrt_aclim1"|cut -d '=' -f2)"
  aclim2="$(cat "./data/config"|grep "wrt_aclim2"|cut -d '=' -f2)"
  unitdv="$(cat "./data/config"|grep "wrt_unitdv"|cut -d '=' -f2)"
fi

if [ "$start" = "" ]; then
  start="01"
fi
  
if [ "$limit1" = "" ]; then
  limit1="0"
fi
  
if [ "$limit2" = "" ]; then
  limit2="0"
fi
    
if [ "$unitdv" = "" ]; then
  unitdv="1048576"
fi

#####calculate previous month/year#####
pmonth="$(expr $month - 1)"
nmonth="$(expr $month + 1)"
pyear="$year"
nyear="$year"
        
[ "$pmonth" -lt "1" ] && pmonth="12" && pyear="$(expr $year - 1)"
[ "$pyear" -lt "0" ] && pyear="99"
[ "$nmonth" -gt "12" ] && nmonth="01" && nyear="$(expr $year + 1)"
[ "$nyear" -gt "99" ] && nyear="00"
[ "$(echo "$pmonth" | wc -c)" -lt 3 ] && pmonth="0$pmonth"
[ "$(echo "$pyear" | wc -c)" -lt 3 ] && pyear="0$pyear"
[ "$(echo "$nmonth" | wc -c)" -lt 3 ] && nmonth="0$nmonth"
[ "$(echo "$nyear" | wc -c)" -lt 3 ] && nyear="0$nyear"

######calculate all days of current billing period#####  
if [ "$day" -lt "$start" ]; then
  listdays=$(echo $pyear $pmonth $start | awk '{for (j=$3;j<=31;j++) printf "./data/%02d%0.2d%02d\n",$1,$2,j}')
  listdays="$listdays $(echo $year $month $start | awk '{for (j=01;j<$3;j++) printf "./data/%02d%0.2d%02d\n",$1,$2,j}')"
  billper="${pyear}${pmonth}"
else
  listdays=$(echo $year $month $start | awk '{for (j=$3;j<=31;j++) printf "./data/%02d%0.2d%02d\n",$1,$2,j}')
  listdays="$listdays $(echo $nyear $nmonth $start | awk '{for (j=01;j<$3;j++) printf "./data/%02d%0.2d%02d\n",$1,$2,j}')"
  billper="${year}${month}"
fi

#####calculate total traffic#####
for daylog in $listdays
do
  if [ -f "$daylog" ]; then 
    daydw=`sed -n '1,1p' $daylog`
    dayup=`sed -n '2,2p' $daylog`
    
    totdw=$(echo $totdw $daydw | awk '{print $1 + $2}')
    totup=$(echo $totup $dayup | awk '{print $1 + $2}')
  
    if [ -f ./data/billvol ]; then
      rm ./data/billvol
    fi
    echo "$totdw" > ./data/billvol
    echo "$totup" >> ./data/billvol
  fi
done

#####get result and adjust units#####
totdw=$(sed -n '1,1p' ./data/billvol)
totup=$(sed -n '2,2p' ./data/billvol)
totbw=$(echo $totdw $totup | awk '{print $1 + $2}')
totdw=$(echo $totdw $unitdv | awk '{print $1 / $2}' | cut -d '.' -f1)
totup=$(echo $totup $unitdv | awk '{print $1 / $2}' | cut -d '.' -f1)
totbw=$(echo $totbw $unitdv | awk '{print $1 / $2}' | cut -d '.' -f1)

if [ ! -f ./data/lastac ]; then
  echo "0" > ./data/lastac
  echo "0" >> ./data/lastac
fi

lastac1=$(sed -n '1,1p' ./data/lastac)
lastac2=$(sed -n '2,2p' ./data/lastac)

rm ./data/lastac   

if [ "$totbw" -gt "$limit1" ] && [ "$totbw" -lt "$limit2" ]; then
  if [ "$lastac1" != "$billper" ]; then
    $aclim1 2> /dev/null
    lastac1="$billper"
  fi
fi

if [ "$totbw" -gt "$limit2" ]; then
  if [ "$lastac2" != "$billper" ]; then
    $aclim2 2> /dev/null
    lastac2="$billper"
  fi
fi

echo "$lastac1" > ./data/lastac
echo "$lastac2" >> ./data/lastac
    
